
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>MogileFS的分布式文件系统的实现 / 憋错料</title>

    <meta name="description" content="MogileFS的分布式文件系统的实现 MogileFS:是一套分布式文件存储的解决方案,它不需要特殊的核心组件.无单点失败.自动的文件复制.比RAID好多了.传输中立,无特殊协议(客户端可以通过NFS或HTTP来和MogileFS通信).简单的命名空间.不用共享任何东西.不需要RAID.不会碰到文件系统本身的不可知情况 等等优点. server端由mogilefsd和mogstored两个程序组成,mogilefsd既tracker,用来存数全局元数据放在数据库中,mogstored既存储节点. 实验目的: 实现mogilefs分布">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">MogileFS的分布式文件系统的实现</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>MogileFS:是一套分布式文件存储的解决方案，它不需要特殊的核心组件、无单点失败、自动的文件复制、比RAID好多了、传输中立，无特殊协议(客户端可以通过NFS或HTTP来和MogileFS通信)、简单的命名空间、不用共享任何东西、不需要RAID、不会碰到文件系统本身的不可知情况 等等优点。</p>
<p>server端由mogilefsd和mogstored两个程序组成，mogilefsd既tracker,用来存数全局元数据放在数据库中，mogstored既存储节点。</p>
<p><strong>实验目的：</strong></p>
<p>实现mogilefs分布式文件系统的实现</p>
<p><strong>实验环境：</strong></p>
<p>node1: 172.16.18.1&nbsp;&nbsp; 程序：mogstord</p>
<p>node2: 172.16.18.2&nbsp;&nbsp; 程序：mogstord</p>
<p>node3: 172.16.18.3&nbsp;&nbsp; 程序：mysql ， mogilefsd(tracker)</p>
<p><strong>实验模型：模型一</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDE0MTAvMi83MDIxMTQyXzE0MTIyMzIwMDFzRjBtLnBuZw==.jpg" /></p>
<p><strong>实验内容：</strong></p>
<p>1.1 配置Tracker</p>
<p>安装MySQL,yum安装</p>
<p>安装Mogilefs</p>
<p>[[email&#160;protected] mogilefs]# yum install MogileFS-Server-* perl-Perlbal-1.78-1.el6.noarch.rpm</p>
<p>Dependency Installed:</p>
<p>perl-BSD-Resource.x86_64 0:1.29.03-3.el6</p>
<p>perl-Danga-Socket.noarch 0:1.61-5.el6</p>
<p>perl-Sys-Syscall.noarch 0:0.23-1.el6</p>
<p>perl-Time-HiRes.x86_64 4:1.9721-136.el6</p>
<p>perl-Net-Netmask.noarch 0:1.9015-8.el6</p>
<p>Complete!</p>
<p>1.2：在数据库创建用户</p>
<p>mysql&gt; GRANT ALL ON mogilefs.* TO ‘mogile‘@‘172.16.%.%‘ IDENTIFIED BY ‘mogile‘;</p>
<p>Query OK, 0 rows affected (0.02 sec)</p>
<p>查看mogilefs的帮助</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mogdbsetup&nbsp;--help&nbsp;&nbsp;&nbsp;&nbsp;
Usage:&nbsp;mogdbsetup&nbsp;[opts]&nbsp;&nbsp;&nbsp;&nbsp;
Options:&nbsp;&nbsp;&nbsp;&nbsp;
Default&nbsp;Description&nbsp;&nbsp;&nbsp;&nbsp;
============&nbsp;===========================================&nbsp;&nbsp;&nbsp;&nbsp;
--verbose&nbsp;&lt;off&gt;&nbsp;Be&nbsp;verbose&nbsp;about&nbsp;what‘s&nbsp;happening.&nbsp;&nbsp;&nbsp;&nbsp;
--dbhost=&nbsp;localhost&nbsp;hostname&nbsp;or&nbsp;IP&nbsp;to&nbsp;database&nbsp;server.&nbsp;&nbsp;&nbsp;&nbsp;
--dbport=&nbsp;dbd&nbsp;default&nbsp;port&nbsp;number&nbsp;to&nbsp;database&nbsp;server.&nbsp;&nbsp;&nbsp;&nbsp;
--dbname=&nbsp;mogilefs&nbsp;database&nbsp;name&nbsp;to&nbsp;create/upgrade.&nbsp;&nbsp;&nbsp;&nbsp;
--dbrootuser=&nbsp;root&nbsp;Database&nbsp;administrator&nbsp;username.&nbsp;Only&nbsp;needed&nbsp;for&nbsp;initial&nbsp;setup,&nbsp;not&nbsp;subsequent&nbsp;upgrades.&nbsp;&nbsp;&nbsp;&nbsp;
--dbrootpass=&nbsp;&lt;blank&gt;&nbsp;Database&nbsp;administrator&nbsp;password.&nbsp;Only&nbsp;needed&nbsp;for&nbsp;initial&nbsp;setup,&nbsp;not&nbsp;subsequent&nbsp;upgrades.&nbsp;&nbsp;&nbsp;&nbsp;
--dbuser=&nbsp;mogile&nbsp;Regular&nbsp;database&nbsp;user&nbsp;to&nbsp;create&nbsp;and/or&nbsp;use&nbsp;for&nbsp;MogileFS&nbsp;database.&nbsp;This&nbsp;is&nbsp;what&nbsp;the&nbsp;mogilefsd&nbsp;trackers&nbsp;connect&nbsp;as.&nbsp;&nbsp;&nbsp;&nbsp;
--dbpass=&nbsp;&lt;blank&gt;&nbsp;You&nbsp;should&nbsp;change&nbsp;this,&nbsp;especially&nbsp;if&nbsp;your&nbsp;database&nbsp;servers&nbsp;are&nbsp;accessible&nbsp;to&nbsp;other&nbsp;users&nbsp;on&nbsp;the&nbsp;network.&nbsp;But&nbsp;they&nbsp;shouldn‘t&nbsp;be&nbsp;if&nbsp;you‘re&nbsp;running&nbsp;MogileFS,&nbsp;because&nbsp;MogileFS&nbsp;assumes&nbsp;your&nbsp;network&nbsp;is&nbsp;closed.&nbsp;&nbsp;&nbsp;&nbsp;
--type=&nbsp;MySQL&nbsp;Which&nbsp;MogileFS::Store&nbsp;implementation&nbsp;to&nbsp;use.&nbsp;Available:&nbsp;MySQL,&nbsp;Postgres&nbsp;&nbsp;&nbsp;&nbsp;
--yes&nbsp;Run&nbsp;without&nbsp;questions.</pre>
<p>如果默认的参数和自己设定的参数一样的话就不需要指定了。</p>
<p>2.1尝试连接</p>
<p>[[email&#160;protected] ~]# mogdbsetup --dbhost=172.16.18.3 --dbpass=mogile &nbsp; &nbsp;<br />This will attempt to setup or upgrade your MogileFS database. &nbsp; &nbsp;<br />It won‘t destroy existing data. &nbsp; &nbsp;<br />Run with --help for more information. Run with --yes to shut up these prompts. &nbsp; &nbsp;<br />Continue? [N/y]: y &nbsp; &nbsp;<br />Create/Upgrade database name ‘mogilefs‘? [Y/n]: y &nbsp; &nbsp;<br />Grant all privileges to user ‘mogile‘, connecting from anywhere, to the mogilefs database ‘mogilefs‘? [Y/n]: y &nbsp; &nbsp;<br />Failed to connect to database as regular user, even after creating it and setting up permissions as the root user. at /usr/share/perl5/vendor_perl/MogileFS/Store.pm line 108, &lt;STDIN&gt; line 3.</p>
<p>报错，我们数据库的root用户没有设定允许远程连接，那我们来授权一个root用户的远程连接</p>
<p>mysql&gt; GRANT ALL ON *.* TO [email&#160;protected]‘172.16.%.%‘ IDENTIFIED BY ‘aolens‘;</p>
<p>Query OK, 0 rows affected (0.00 sec)</p>
<p>[[email&#160;protected] ~]# mogdbsetup --dbhost=172.16.18.3 --dbpass=mogile --dbrootuser=root --dbrootpass=aolens; &nbsp; &nbsp;<br />This will attempt to setup or upgrade your MogileFS database. &nbsp; &nbsp;<br />It won‘t destroy existing data. &nbsp; &nbsp;<br />Run with --help for more information. Run with --yes to shut up these prompts. &nbsp; &nbsp;<br />Continue? [N/y]: y &nbsp; &nbsp;<br />Failed to connect to DBI:mysql:mysql;host=172.16.18.3;port=3306 as specified root user (root): Access denied for user ‘root‘@‘node3.aolens.com‘ (using password: YES)</p>
<p>又报出错误，解析用的是node3.aolens.com</p>
<p>mysql&gt; GRANT ALL ON mogilefs.* TO ‘mogile‘@‘node3.aolens.com‘ IDENTIFIED BY ‘mogile‘;</p>
<p>Query OK, 0 rows affected (0.00 sec)</p>
<p>mysql&gt; flush privileges;</p>
<p>Query OK, 0 rows affected (0.00 sec)</p>
<p>[[email&#160;protected] ~]# mogdbsetup --dbhost=172.16.18.3 --dbpass=mogile --dbrootuser=root --dbrootpass=aolens; &nbsp; &nbsp;<br />This will attempt to setup or upgrade your MogileFS database. &nbsp; &nbsp;<br />It won‘t destroy existing data. &nbsp; &nbsp;<br />Run with --help for more information. Run with --yes to shut up these prompts. &nbsp; &nbsp;<br />Continue? [N/y]: y</p>
<p>OK.连接成功</p>
<p>查看数据库中生成的数据</p>
<p>mysql&gt; show tables;</p>
<p>有生成数据即可</p>
<p>我们是yum安装的MySQL，version:5.1.71的，</p>
<p>mysql&gt; show tables status\G&nbsp;&nbsp;&nbsp; 查看存储引擎是不是innodb,若是则OK</p>
<p>2.2，编辑MogileFS的配置文件，配置一下参数。</p>
<p>[[email&#160;protected] ~]# vim /etc/mogilefs/mogilefsd.conf</p>
<pre>db_dsn&nbsp;=&nbsp;DBI:mysql:mogilefs:host=172.16.18.3&nbsp;&nbsp;#如果使用的数据库不是mogilefs，则修改mogilefs为自己定义的数据库
db_user&nbsp;=&nbsp;mogilef
db_pass&nbsp;=&nbsp;mogile
listen&nbsp;=&nbsp;172.16.18.3:7001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#监听的地址和端口</pre>
<p>2.3 尝试启动mogilefs</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;service&nbsp;mogilefsd&nbsp;start&nbsp;&nbsp;&nbsp;&nbsp;
Starting&nbsp;mogilefsd&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[FAILED]</pre>
<p>无法启动？我们尝试连接数据库看能否连接</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;mysql&nbsp;-uroot&nbsp;-h172.16.18.3&nbsp;-p&nbsp;&nbsp;&nbsp;&nbsp;Enter&nbsp;password:&nbsp;&nbsp;&nbsp;&nbsp;ERROR&nbsp;1045&nbsp;(28000):&nbsp;Access&nbsp;denied&nbsp;for&nbsp;user&nbsp;‘root‘@‘node3.aolens.com‘&nbsp;(using&nbsp;password:&nbsp;YES)
数据库连接出错，解析用的是主机名。创建下边用户
mysql&gt;&nbsp;GRANT&nbsp;ALL&nbsp;ON&nbsp;*.*&nbsp;TO&nbsp;[email&#160;protected]‘node3.aolens.com‘&nbsp;IDENTIFIED&nbsp;BY&nbsp;‘aolens‘;
Query&nbsp;OK,&nbsp;0&nbsp;rows&nbsp;affected&nbsp;(0.06&nbsp;sec)
mysql&gt;&nbsp;flush&nbsp;privileges;
Query&nbsp;OK,&nbsp;0&nbsp;rows&nbsp;affected&nbsp;(0.00&nbsp;sec)</pre>
<p>再次启动</p>
<p>[[email&#160;protected] ~]# service mogilefsd restart &nbsp; &nbsp;<br />Starting mogilefsd&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; [ OK ]</p>
<p>启动成功了。</p>
<p>3.1下来我们来配置mogstord</p>
<p>首先来安装需要的程序包</p>
<p>perl-IO-AIO.x86_64 0:3.71-2.el6</p>
<p>MogileFS-Server-2.46-2.el6.noarch</p>
<p>MogileFS-Server-mogilefsd-2.46-2.el6.noarch</p>
<p>MogileFS-Server-mogstored-2.46-2.el6.noarch</p>
<p>perl-Net-Netmask-1.9015-8.el6.noarch</p>
<p>perl-Perlbal-1.78-1.el6.noarch</p>
<p>3.2第二步来配置mogstored.conf ,在node1 ，node2上同时配置。</p>
<pre>[[email&#160;protected]&nbsp;mogilefs]#&nbsp;vim&nbsp;/etc/mogilefs/mogstored.conf&nbsp;&nbsp;&nbsp;&nbsp;
maxconns&nbsp;=&nbsp;10000&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#最大连接并发数&nbsp;&nbsp;&nbsp;&nbsp;
httplisten&nbsp;=&nbsp;0.0.0.0:7500&nbsp;&nbsp;&nbsp;&nbsp;
mgmtlisten&nbsp;=&nbsp;0.0.0.0:7501&nbsp;&nbsp;&nbsp;&nbsp;
docroot&nbsp;=&nbsp;/mogilefs/data</pre>
<p>3.3，创建需要的数据目录</p>
<p>[[email&#160;protected] ~]# mkdir /mogilefs/data &nbsp; &nbsp;<br />[[email&#160;protected] ~]# chown -R mogilefs.mogilefs /mogilefs/</p>
<p>3.4 启动mogstored</p>
<p>[[email&#160;protected] mogilefs]# service mogstored start &nbsp; &nbsp;<br />Starting mogstored [ OK ]</p>
<p>[[email&#160;protected] mogilefs]# ss -tnl</p>
<p>LISTEN 0 128 *:7500 *:*</p>
<p>LISTEN 0 128 *:7501 *:*</p>
<p>3.5 要实现对此节点的控制需要在node1:tracker上安装</p>
<p>MogileFS-Utils-2.19-1.el6.noarch.rpm</p>
<p>perl-MogileFS-Client-1.14-1.el6.noarch.rpm</p>
<p>4.1下来我们来为tracker添加主机</p>
<p>[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 host add node1 --ip=172.16.18.1 --status=alive &nbsp; &nbsp;<br />[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 host add node2 --ip=172.16.18.2 --status=alive &nbsp; &nbsp;<br />查看添加的主机：</p>
<p>[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 host list &nbsp; &nbsp;<br />node1 [1]: alive &nbsp; &nbsp;<br />IP: 172.16.18.1:7500 &nbsp; &nbsp;<br />node2 [2]: alive &nbsp; &nbsp;<br />IP: 172.16.18.2:7500</p>
<p>可以标记那个节点软下线</p>
<p>mogadm --trackers=172.16.18.3:7001 host mask node1 down</p>
<p>4.2添加设备</p>
<p>查看设备。可以看到有两个节点，但是上边什么设备都没有</p>
<p>[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 device list &nbsp; &nbsp;<br />node1 [1]: alive &nbsp; &nbsp;<br />used(G) free(G) total(G) weight(%) &nbsp; &nbsp;<br />node2 [2]: alive &nbsp; &nbsp;<br />used(G) free(G) total(G) weight(%)</p>
<p>添加设备的语法</p>
<p>mogadm device add &lt;hostname&gt; &lt;devid&gt; [opts]&nbsp;&nbsp; Add a device to a host.</p>
<p>&lt;devid&gt; Numeric devid. Never reuse these.</p>
<p>&lt;hostname&gt; Hostname to add a device</p>
<p>--status=s One of ‘alive‘ or ‘down‘. Defaults to ‘alive‘.</p>
<p>添加设备并查询</p>
<p>[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 device add node1 1 --status=alive &nbsp; &nbsp;<br />[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 device add node2 2 --status=alive &nbsp; &nbsp;<br />[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 device list &nbsp; &nbsp;<br />node1 [1]: alive &nbsp; &nbsp;<br />used(G) free(G) total(G) weight(%) &nbsp; &nbsp;<br />dev1: alive 0.000 0.000 0.000 100 &nbsp; &nbsp;<br />node2 [2]: alive &nbsp; &nbsp;<br />used(G) free(G) total(G) weight(%) &nbsp; &nbsp;<br />dev2: alive 0.000 0.000 0.000 100</p>
<p>设备添加进来了，可是设备的大小都为0</p>
<p>[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 device summary &nbsp; &nbsp;<br />Hostname HostID Status used(G) free(G) total(G) %Used &nbsp; &nbsp;<br />node1 [ 1]: alive 0.000 0.000 0.000 &nbsp; &nbsp;<br />node2 [ 2]: alive 0.000 0.000 0.000</p>
<p>那么在node1创建/mogilefs/data/dev1 并修改权限</p>
<p>在node2创建/mogilefs/data/dev2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 同上</p>
<p>[[email&#160;protected] ~]# chown -R mogilefs.mogilefs /mogilefs/</p>
<p>[[email&#160;protected] data]# chown -R mogilefs.mogilefs /mogilefs/</p>
<p>[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 device summary &nbsp; &nbsp;<br />Hostname HostID Status used(G) free(G) total(G) %Used &nbsp; &nbsp;<br />node1 [ 1]: alive 0.536 18.149 18.686 2.87 &nbsp; &nbsp;<br />node2 [ 2]: alive 0.537 18.148 18.686 2.87</p>
<p>存储大小出来了</p>
<p>4.3 添加domain名称空间</p>
<p>[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 domain add file &nbsp; &nbsp;<br />[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.18.3:7001 domain list &nbsp; &nbsp;<br />domain&nbsp;&nbsp;&nbsp;&nbsp; class&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; mindevcount&nbsp;&nbsp;&nbsp;&nbsp; replpolicy&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hashtype &nbsp; &nbsp;<br />-------------------- -------------------- ------------- ------------ ------- &nbsp; &nbsp;<br />file&nbsp;&nbsp;&nbsp;&nbsp; default&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; MultipleHosts()&nbsp;&nbsp;&nbsp;&nbsp; NONE</p>
<p>其中的2是复制时保存几份副本。在class中定义</p>
<p>4.4 上传数据，mogupload</p>
<p>[[email&#160;protected] mogilefs]# mogupload --trackers=172.16.18.3:7001 --domain=file --key=‘/fstab‘ --file=‘/etc/fstab‘</p>
<p>4.5 查询上传数据文件mogfileinfo</p>
<p>[[email&#160;protected] mogilefs]# mogfileinfo --trackers=172.16.18.3:7001 --domain=file --key=‘/fstab‘ &nbsp; &nbsp;<br />- file: /fstab &nbsp; &nbsp;<br />class: default &nbsp; &nbsp;<br />devcount: 2 &nbsp; &nbsp;<br />domain: file &nbsp; &nbsp;<br />fid: 2 &nbsp; &nbsp;<br />key: /fstab &nbsp; &nbsp;<br />length: 805 &nbsp; &nbsp;<br />- <a href="http://172.16.18.2/" rel="external nofollow noreferrer">http://172.16.18.2</a>:7500/dev2/0/000/000/0000000002.fid &nbsp; &nbsp;<br />- <a href="http://172.16.18.1/" rel="external nofollow noreferrer">http://172.16.18.1</a>:7500/dev1/0/000/000/0000000002.fid</p>
<p>在浏览器上输入路径，查看内容</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDE0MTAvMi83MDIxMTQyXzE0MTIyMzIwMDVMa0FzLnBuZw==.jpg" /></p>
<p>再来上传一个图片</p>
<p>[[email&#160;protected] mogilefs]# mogupload --trackers=172.16.18.3:7001 --domain=images --key=‘/images‘ --file=‘/usr/share/backgrounds/default.png‘ &nbsp; &nbsp;<br />[[email&#160;protected] mogilefs]# mogfileinfo --trackers=172.16.18.3:7001 --domain=images --key=‘/images‘ &nbsp; &nbsp;<br />- file: /images &nbsp; &nbsp;<br />class: default &nbsp; &nbsp;<br />devcount: 2 &nbsp; &nbsp;<br />domain: images &nbsp; &nbsp;<br />fid: 3 &nbsp; &nbsp;<br />key: /images &nbsp; &nbsp;<br />length: 1470177 &nbsp; &nbsp;<br />- <a href="http://172.16.18.2/" rel="external nofollow noreferrer">http://172.16.18.2</a>:7500/dev2/0/000/000/0000000003.fid &nbsp; &nbsp;<br />- <a href="http://172.16.18.1/" rel="external nofollow noreferrer">http://172.16.18.1</a>:7500/dev1/0/000/000/0000000003.fid</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDE0MTAvMi83MDIxMTQyXzE0MTIyMzIwMjZOaEhBLnBuZw==.jpg" /></p>
<p>4.6 下载命令语法</p>
<p>[[email&#160;protected] mogilefs]# mogfetch --help &nbsp; &nbsp;<br />Usage: /usr/bin/mogfetch --trackers=host --domain=foo --key=‘/hello.jpg‘ --file=‘./output‘</p>
<p>4.7 重命名语法</p>
<p>[[email&#160;protected] mogilefs]# mogrename --help &nbsp; &nbsp;<br />Usage: /usr/bin/mogrename --trackers=host --domain=foo --class=bar --old_key=‘/hello.jpg‘ --new_key=‘/bye.jpg‘</p>
<p>4.8 列出所有的KEY</p>
<p>[[email&#160;protected] mogilefs]# mogrename --help &nbsp; &nbsp;<br />Usage: /usr/bin/mogrename --trackers=host --domain=foo --class=bar --old_key=‘/hello.jpg‘ --new_key=‘/bye.jpg‘ &nbsp; &nbsp;<br />[[email&#160;protected] mogilefs]# moglistkeys --help &nbsp; &nbsp;<br />Usage: /usr/bin/moglistkeys --trackers=host --domain=foo --key_prefix=‘bar/‘</p>
<p>模型二：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDE0MTAvMi83MDIxMTQyXzE0MTIyMzIwMzZtaXJTLnBuZw==.jpg" /></p>
<p>这种模型既可以实现tracker的高可用</p>
<p>但是此时访问存储的数据太过复杂，那么我们又该如何部署使得访问变得简单，不用直接面对设备中的fid数据文件呢？</p>
<p>nginx这个程序具有第三方模块mogilefs就可以实现将url转为存储设备中的fid文件，也可以将fid数据转为url.所以我们只需要基于http协议在浏览器上直接访问数据的url就可以直观的查看到数据文件了。</p>
<p>nginx需要支持第三方模块的话需要自己编译nginx将第三方模块添加进来。</p>
<p>为node1，node2安装tracker.</p>
<p>5.1 编译安装nginx以及第三方模块nginx_mogilefs_module-1.0.4.tar.gz</p>
<p>解压nginx源码包和模块</p>
<p>进入nginx解压包</p>
<pre>#&nbsp;./configure&nbsp;&nbsp;&nbsp;--prefix=/usr&nbsp;&nbsp;&nbsp;--sbin-path=/usr/sbin/nginx&nbsp;&nbsp;&nbsp;--conf-path=/etc/nginx/nginx.conf&nbsp;&nbsp;&nbsp;--error-log-path=/var/log/nginx/error.log&nbsp;&nbsp;&nbsp;--http-log-path=/var/log/nginx/access.log&nbsp;&nbsp;&nbsp;--pid-path=/var/run/nginx/nginx.pid&nbsp;&nbsp;&nbsp;--lock-path=/var/lock/nginx.lock&nbsp;&nbsp;&nbsp;--user=nginx&nbsp;&nbsp;&nbsp;--group=nginx&nbsp;&nbsp;&nbsp;--with-http_ssl_module&nbsp;&nbsp;&nbsp;--with-http_flv_module&nbsp;&nbsp;&nbsp;--with-http_stub_status_module&nbsp;&nbsp;&nbsp;--with-http_gzip_static_module&nbsp;&nbsp;&nbsp;--http-client-body-temp-path=/var/tmp/nginx/client/&nbsp;&nbsp;&nbsp;--http-proxy-temp-path=/var/tmp/nginx/proxy/&nbsp;&nbsp;&nbsp;--http-fastcgi-temp-path=/var/tmp/nginx/fcgi/&nbsp;&nbsp;&nbsp;--http-uwsgi-temp-path=/var/tmp/nginx/uwsgi&nbsp;&nbsp;&nbsp;--http-scgi-temp-path=/var/tmp/nginx/scgi&nbsp;&nbsp;&nbsp;--with-pcre&nbsp;&nbsp;&nbsp;--with-debug&nbsp;&nbsp;&nbsp;--add-module=&nbsp;../nginx_mogilefs_module-1.0.4/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#第三方模块的位置</pre>
<p>检测有问题，缺少依赖关系</p>
<p>yum install pcre-devel</p>
<p># make &amp;&amp; make install</p>
<p>3、为nginx提供SysV init脚本:</p>
<p>新建文件/etc/rc.d/init.d/nginx，内容如下：</p>
<pre>#!/bin/sh
#
#&nbsp;nginx&nbsp;-&nbsp;this&nbsp;script&nbsp;starts&nbsp;and&nbsp;stops&nbsp;the&nbsp;nginx&nbsp;daemon
#
#&nbsp;chkconfig:&nbsp;-&nbsp;85&nbsp;15
#&nbsp;description:&nbsp;Nginx&nbsp;is&nbsp;an&nbsp;HTTP(S)&nbsp;server,&nbsp;HTTP(S)&nbsp;reverse&nbsp;#&nbsp;proxy&nbsp;and&nbsp;IMAP/POP3&nbsp;proxy&nbsp;server
#&nbsp;processname:&nbsp;nginx
#&nbsp;config:&nbsp;/etc/nginx/nginx.conf
#&nbsp;config:&nbsp;/etc/sysconfig/nginx
#&nbsp;pidfile:&nbsp;/var/run/nginx.pid
#&nbsp;Source&nbsp;function&nbsp;library.
.&nbsp;/etc/rc.d/init.d/functions
#&nbsp;Source&nbsp;networking&nbsp;configuration.
.&nbsp;/etc/sysconfig/network
#&nbsp;Check&nbsp;that&nbsp;networking&nbsp;is&nbsp;up.
[&nbsp;"$NETWORKING"&nbsp;=&nbsp;"no"&nbsp;]&nbsp;&amp;&amp;&nbsp;exit&nbsp;0
nginx="/usr/sbin/nginx"
prog=$(basename&nbsp;$nginx)
NGINX_CONF_FILE="/etc/nginx/nginx.conf"
[&nbsp;-f&nbsp;/etc/sysconfig/nginx&nbsp;]&nbsp;&amp;&amp;&nbsp;.&nbsp;/etc/sysconfig/nginx
lockfile=/var/lock/subsys/nginx
make_dirs()&nbsp;{
&nbsp;&nbsp;&nbsp;#&nbsp;make&nbsp;required&nbsp;directories
&nbsp;&nbsp;&nbsp;user=`nginx&nbsp;-V&nbsp;2&gt;&amp;1&nbsp;|&nbsp;grep&nbsp;"configure&nbsp;arguments:"&nbsp;|&nbsp;sed&nbsp;‘s/[^*]*--user=\([^&nbsp;]*\).*/\1/g‘&nbsp;-`
&nbsp;&nbsp;&nbsp;options=`$nginx&nbsp;-V&nbsp;2&gt;&amp;1&nbsp;|&nbsp;grep&nbsp;‘configure&nbsp;arguments:‘`
&nbsp;&nbsp;&nbsp;for&nbsp;opt&nbsp;in&nbsp;$options;&nbsp;do
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;[&nbsp;`echo&nbsp;$opt&nbsp;|&nbsp;grep&nbsp;‘.*-temp-path‘`&nbsp;];&nbsp;then
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value=`echo&nbsp;$opt&nbsp;|&nbsp;cut&nbsp;-d&nbsp;"="&nbsp;-f&nbsp;2`
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;[&nbsp;!&nbsp;-d&nbsp;"$value"&nbsp;];&nbsp;then
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#&nbsp;echo&nbsp;"creating"&nbsp;$value
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mkdir&nbsp;-p&nbsp;$value&nbsp;&amp;&amp;&nbsp;chown&nbsp;-R&nbsp;$user&nbsp;$value
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fi
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fi
&nbsp;&nbsp;&nbsp;done
}
start()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;[&nbsp;-x&nbsp;$nginx&nbsp;]&nbsp;||&nbsp;exit&nbsp;5
&nbsp;&nbsp;&nbsp;&nbsp;[&nbsp;-f&nbsp;$NGINX_CONF_FILE&nbsp;]&nbsp;||&nbsp;exit&nbsp;6
&nbsp;&nbsp;&nbsp;&nbsp;make_dirs
&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;-n&nbsp;$"Starting&nbsp;$prog:&nbsp;"
&nbsp;&nbsp;&nbsp;&nbsp;daemon&nbsp;$nginx&nbsp;-c&nbsp;$NGINX_CONF_FILE
&nbsp;&nbsp;&nbsp;&nbsp;retval=$?
&nbsp;&nbsp;&nbsp;&nbsp;echo
&nbsp;&nbsp;&nbsp;&nbsp;[&nbsp;$retval&nbsp;-eq&nbsp;0&nbsp;]&nbsp;&amp;&amp;&nbsp;touch&nbsp;$lockfile
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;$retval
}
stop()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;-n&nbsp;$"Stopping&nbsp;$prog:&nbsp;"
&nbsp;&nbsp;&nbsp;&nbsp;killproc&nbsp;$prog&nbsp;-QUIT
&nbsp;&nbsp;&nbsp;&nbsp;retval=$?
&nbsp;&nbsp;&nbsp;&nbsp;echo
&nbsp;&nbsp;&nbsp;&nbsp;[&nbsp;$retval&nbsp;-eq&nbsp;0&nbsp;]&nbsp;&amp;&amp;&nbsp;rm&nbsp;-f&nbsp;$lockfile
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;$retval
}
restart()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;configtest&nbsp;||&nbsp;return&nbsp;$?
&nbsp;&nbsp;&nbsp;&nbsp;stop
&nbsp;&nbsp;&nbsp;&nbsp;sleep&nbsp;1
&nbsp;&nbsp;&nbsp;&nbsp;start
}
reload()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;configtest&nbsp;||&nbsp;return&nbsp;$?
&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;-n&nbsp;$"Reloading&nbsp;$prog:&nbsp;"
&nbsp;&nbsp;&nbsp;&nbsp;killproc&nbsp;$nginx&nbsp;-HUP
&nbsp;&nbsp;&nbsp;&nbsp;RETVAL=$?
&nbsp;&nbsp;&nbsp;&nbsp;echo
}
force_reload()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;restart
}
configtest()&nbsp;{
&nbsp;&nbsp;$nginx&nbsp;-t&nbsp;-c&nbsp;$NGINX_CONF_FILE
}
rh_status()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;status&nbsp;$prog
}
rh_status_q()&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;rh_status&nbsp;&gt;/dev/null&nbsp;2&gt;&amp;1
}
case&nbsp;"$1"&nbsp;in
&nbsp;&nbsp;&nbsp;&nbsp;start)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status_q&nbsp;&amp;&amp;&nbsp;exit&nbsp;0
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$1
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;stop)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status_q&nbsp;||&nbsp;exit&nbsp;0
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$1
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;restart|configtest)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$1
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;reload)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status_q&nbsp;||&nbsp;exit&nbsp;7
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$1
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;force-reload)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;force_reload
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;status)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;condrestart|try-restart)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rh_status_q&nbsp;||&nbsp;exit&nbsp;0
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;;;
&nbsp;&nbsp;&nbsp;&nbsp;*)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;$"Usage:&nbsp;$0&nbsp;{start|stop|status|restart|condrestart|try-restart|reload|force-reload|configtest}"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;exit&nbsp;2
esac</pre>
<p>而后为此脚本赋予执行权限：</p>
<p>[[email&#160;protected] ~]# chmod +x /etc/rc.d/init.d/nginx</p>
<p>添加至服务管理列表，并让其开机自动启动：</p>
<p>[[email&#160;protected] ~]# chkconfig --add nginx</p>
<p>[[email&#160;protected] ~]# chkconfig nginx off</p>
<p>[[email&#160;protected] ~]# service nginx start</p>
<p>nginx: the configuration file /etc/nginx/nginx.conf syntax is ok&nbsp; <br />nginx: configuration file /etc/nginx/nginx.conf test is successful</p>
<p>Starting nginx:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; [ OK ]</p>
<p>启动成功，下边我们来配置nginx的配置文件，让他可以代理tracker,并转换fid格式为url</p>
<p>首先备份一份配置文件，再来编辑</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;vim&nbsp;/etc/nginx/nginx.conf
http&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;include&nbsp;mime.types;
&nbsp;&nbsp;&nbsp;&nbsp;default_type&nbsp;application/octet-stream;
&nbsp;&nbsp;&nbsp;&nbsp;sendfile&nbsp;on;
&nbsp;&nbsp;&nbsp;&nbsp;keepalive_timeout&nbsp;65;
&nbsp;&nbsp;&nbsp;&nbsp;server&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;listen&nbsp;80;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;server_name&nbsp;localhost;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;location&nbsp;/file&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_tracker&nbsp;172.16.18.3:7001;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_domain&nbsp;file;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_pass&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_pass&nbsp;$mogilefs_path;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_hide_header&nbsp;Content-Type;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_buffering&nbsp;off;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;location&nbsp;/images&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_tracker&nbsp;172.16.18.3:7001;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_domain&nbsp;images;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mogilefs_pass&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_pass&nbsp;$mogilefs_path;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_hide_header&nbsp;Content-Type;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;proxy_buffering&nbsp;off;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}
}</pre>
<p>重启一下nginx</p>
<p>[email&#160;protected] nginx-1.6.1]# service nginx restart &nbsp; &nbsp;<br />nginx: the configuration file /etc/nginx/nginx.conf syntax is ok &nbsp; &nbsp;<br />nginx: configuration file /etc/nginx/nginx.conf test is successful &nbsp; &nbsp;<br />Stopping nginx:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; [ OK ] &nbsp; &nbsp;<br />Starting nginx:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; [ OK ]</p>
<p>访问http://172.16.18.3/file/fstab,可是没有打开，直接下载了？这是为什么呢？</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDE0MTAvMi83MDIxMTQyXzE0MTIyMzIwMzdIdVdGLnBuZw==.jpg" /></p>
<p>查看一下上传的file中的fstab没有加后缀，可能网页无法识别</p>
<p>再次上传文件，这次给加上后缀.html</p>
<p>[[email&#160;protected] ~]# mogupload --trackers=172.16.18.3:7001 --domain=file --key=‘/passwd.html‘ --file=‘/etc/passwd‘</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDE0MTAvMi83MDIxMTQyXzE0MTIyMzIwMzlaQVNuLnBuZw==.jpg" /></p>
<p>访问没有问题。也重新上传一个图片</p>
<p>[[email&#160;protected] ~]# mogupload --trackers=172.16.18.3:7001 --domain=images --key=‘/image.png‘ --file=‘/usr/share/backgrounds/wallpaper-six-2048x1536.png‘</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDE0MTAvMi83MDIxMTQyXzE0MTIyMzIwNjBrNENQLnBuZw==.jpg" /></p>
<p>此时基于GET方法的请求文件打开就没有问题了。</p>
<p>mogilefs模块的put方法无法再nginx1.0以上的版本上运行，此处不做介绍。</p>
<p>实现到此结束</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 13:16:56 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e8%a7%a3%e5%86%b3%e6%96%b9%e6%a1%88/" title="解决方案">解决方案</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.biecuoliao.com/tag/server/" title="server">server</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%a2%e6%88%b7%e7%ab%af/" title="客户端">客户端</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%9e%e9%aa%8c%e7%9b%ae%e7%9a%84/" title="实验目的">实验目的</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>MogileFS的分布式文件系统的实现的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OdZdZ4.html" rel="bookmark">基于mogileFS搭建分布式文件系统--海量小文件的存储利器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.分布式文件系统    1.简介 分布式文件系统(Distributed File System)是指文件系统管理的物理存储资源不一定直接连接在本地节点上,而是通过计算机网络与节点相连.分布式文件系统的设计基于客户机/服务器模式.一个典型的网络可能包括多个供多用户访问的服务器.另外,对等特性允许一些系统扮演客户机和服务器的双重角色.例如,用户可以&quot;发表&quot;一个允许其他客户机访问的目录,一旦被访问,这个目录对客户机来说就像使用本地驱动器一样. 当下我们处在一个互联网飞速发展的信息社会,在			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lNQ6P4.html" rel="bookmark">基于mogileFS搭建分布式文件系统 适用于海量小文件的存储</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.分布式文件系统 1.简介 分布式文件系统(Distributed File System)是指文件系统管理的物理存储资源不一定直接连接在本地节点上,而是通过计算机网络与节点相连.分布式文件系统的设计基于客户机/服务器模式.一个典型的网络可能包括多个供多用户访问的服务器.另外,对等特性允许一些系统扮演客户机和服务器的双重角色.例如,用户可以&quot;发表&quot;一个允许其他客户机访问的目录,一旦被访问,这个目录对客户机来说就像使用本地驱动器一样. 当下我们处在一个互联网飞速发展的信息社会,在海量并			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dgQoeM.html" rel="bookmark">分布式文件系统之&amp;mdash&semi;&amp;mdash&semi;mogilefs</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节我们将来认识下分布式文件系统,不过我主要讲的是关于其中的一个比较流行的mogilefs进行介绍,好了其他的不多说了,下面我们就开始吧. 什么是分布式文件系统? 什么是分布式文件系统(Distributed File System)?顾名思义,就是分布式+文件系统.它包含了2方面,从文件系统的客户端的角度来看,他就是一个标准的文件系统,提供了API,由此可以进行文件的创建.删除.读写等操作:从内部来看的话,分布式文件系统则与普通的文件系统不同,它不在是本地的磁盘中,它的内容和目录都不是存储在本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a7mmP4.html" rel="bookmark">CentOS 6&period;5 分布式文件系统之MogileFS工作原理及实现过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   MogileFS是一套高效的文件自动备份组件,由Six Apart开发,广泛应用在包括LiveJournal等web2.0站点上.MogileFS由3个部分组成:    第1个部分:是server端,包括mogilefsd和mogstored两个程序.前者即是mogilefsd的tracker,它将一些全局信息保存在数据库里,例如站点domain,class,host等.后者即是存储节点(store node),它其实是个HTTP Daemon,默认侦听在7500端口,接受客户端的文件备份			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M61mjN4.html" rel="bookmark">Nginx&plus;MogileFS分布式文件系统部署实验</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				实验要求 1.  部署mogilefs分布式文件系统 2.  nginx代理 实验环境 1.拓扑 2.网络地址规划 node1:172.16.76.10 nginx (centos6.8) node2:172.16.76.20 Trackers .storage Node   (centos7.2) node3:172.16.76.30 storage Node                   (centos7.2) node4:172.16.76.40 storage Node  (Mar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35qjYR3.html" rel="bookmark">Mogilefs分布式文件系统-Keepalived&plus;Nginx双主模型实现图片分布式存储、访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.分布式文件系统: 分布式文件系统(Distributed File System)是指文件系统管理的物理存储资源不一定直接连接在本地节点上,而是通过计算机网络与节点相连.计算机通过文件系统管理.存储数据,单纯通过增加硬盘个数来扩展计算机文件系统的存储容量的方式,在容量大小.容量增长速度.数据备份.数据安全等方面的表现都差强人意. 分布式文件系统可以有效解决数据的存储和管理难题:将固定于某个地点的某个文件系统,扩展到任意多个地点/多个文件系统,众多的节点组成一个文件系统网络.每个节点可以分布在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4J8QqD0.html" rel="bookmark">MogileFS分布式文件系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内容概述 1.分布式文件系统介绍 2.CAP理论 3.常见分布式文件系统介绍 4.MogileFS详细介绍 4.1MogileFS组成 4.2MogileFS特性 5.MogileFS实现 5.1 node1配置Mariadb(过程略) 5.2 node1配置tracker 5.3 node2配置storage 5.4  node3配置storage 5.5 配置分布式集群 5.5.1 添加主机 5.5.2 添加设备 5.5.3 定义domain和class 5.6  验证分布式集群 6.Mog			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xr9kL4.html" rel="bookmark">共享存储之分布式文件系统应用及MogileFS基础应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 **什么是分布式存储:    分布式存储系统,是将数据分散存储在多台独立的设备上.传统的网络存储系统采用集中的存储服务器存放所有数据,存储服务器成为系统性能的瓶颈,也是可靠性和安全性的焦点,不能满足大规模存储应用的需要.分布式网络存储系统采用可扩展的系统结构,利用多台存储服务器分担存储负荷,利用位置服务器定位存储信息,它不但提高了系统的可靠性.可用性和存取效率,还易于扩展. 分布式文件系统设计目标: ** 访问透明** 位置透明** 并发透明** 失效透明** 硬件透明** 可扩展性** 复制			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBxozE3.html" rel="bookmark">深入浅出分布式文件系统MogileFS集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    一,简介    MogileFS是一款开源的分布式文件存储系统,由LiveJournal旗下的Danga Interactive公司开发.Danga团队开发了包括 Memcached.MogileFS.Perlbal 等多个知名的开源项目.目前MogileFS的日益成熟使用此解决方法的公司越来越多,例如日本的又拍.digg.中国的豆瓣.1号店.大众点评.搜狗和安居客等,分别为所在的组织或公司管理着海量的图片.和传统网络存储不一样的是分布式文件系统是将数据分散存储至多台服务器上,而网络文件			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0lDrW0.html" rel="bookmark" class="title">【啊哈！算法】算法10：二叉树</a>
					<div>
						二叉树是一种特殊的树.二叉树的特点是每个结点最多有两个儿子,左边的叫做左儿子,右边的叫做右儿子,或者说每个结点最多有两棵子树.更加严格的递归定义是:二叉树要么为空,要么由根结点.左子树和右子树组成,而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/1387AR0.html" rel="bookmark" class="title">服务器遇到大流量攻击的处理过程</a>
					<div>
						案例描述 早上接到IDC的电话,说我们的一个网段IP不停的向外发包,应该是被攻击了,具体哪个IP不知道,让我们检查一下. 按理分析及解决办法 首先我们要先确定是哪台机器的网卡在向外发包,还好我们这边有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0lJ7b4.html" rel="bookmark" class="title">Keil uVision4复杂运用教程</a>
					<div>
						起首,我们用 Keil 先翻开一个现成的工程,来看法一下 Keil 软件,如图 1-7 所示. 图1-7 工程文件 从图 1-7 我们可以很轻松的分辩出菜单栏.工具栏.工程治理区.程序代码区和信息输入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/D3Og9r3.html" rel="bookmark" class="title">iOS利用HealthKit框架从健康app中获取步数信息</a>
					<div>
						微信和QQ的每日步数最近十分火爆,我就想为自己写的项目中添加一个显示每日步数的功能,上网一搜好像并有相关的详细资料,自己动手丰衣足食. 统计步数信息并不需要我们自己去实现,iOS自带的健康app已经为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knBOjM.html" rel="bookmark" class="title">hdu2444 The Accomodation of Students&lpar;判断二分匹配&plus;最大匹配&rpar;</a>
					<div>
						//判断是否为二分图:在无向图G中,如果存在奇数回路,则不是二分图.否则是二分图. //判断回路奇偶性:把相邻两点染成黑白两色,如果相邻两点出现颜色相同则存在奇数回路.也就是非二分图. # inclu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5Adq4.html" rel="bookmark" class="title">Go语言面组合式向对象编程基础总结</a>
					<div>
						Go语言的面向对象编程简单而干净,通过非侵入式接口模型,否定了C/C++ Java C#等传统面向对象编程语言的复杂度的必要性,我们发现在Go中即使简单的组合也能达到传统面向对象语言的效果,而且耦合度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MG8evV0.html" rel="bookmark" class="title">java&period;lang&period;ClassCastException&colon; com&period;sun&period;proxy&period;&dollar;Proxy13 cannot be cast to sm&period;dao&period;UserDao</a>
					<div>
						在Spring中添加事物管理以后出现的问题 源代码 ApplicationContext applicationContext = new ClassPathXmlApplicationContext ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xrDzB4.html" rel="bookmark" class="title">文件流和字节流</a>
					<div>
						所有的IO操作都由以下步骤构成:1.建立流.根据数据源和具体的操作选择流,然后建立流.通过流的建立,创建内存到数据源之间的数据通道,以传输数据.2.操作流.将数据读取到内存,或将内存中的数据写入数据源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Moxv8x0.html" rel="bookmark" class="title">AndroidStudio插件大全</a>
					<div>
						Android-Studio-Plugins 原文地址:https://github.com/itgoyo/Android-Studio-Plugins 欢迎star~~~ Android-Studi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dN5rn4.html" rel="bookmark" class="title">20160401作业张涵</a>
					<div>
						第十章  合同管理 1.合同按照信息系统工程范围划分哪几类? 项目总承包合同.项目单项承包合同.项目分包合同. 2.签订分包合同,应具备的2个条件是什么? (1)总承建单位只能将自己承包的部分项目分包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODEB74.html" rel="bookmark" class="title">SDUT中大数实现的题目，持续更新（JAVA实现）</a>
					<div>
						SDUT2525:A-B (模板题) import java.util.Scanner; import java.math.*; public class Main { public static v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LLpg3.html" rel="bookmark" class="title">linux查看前几条命令记录</a>
					<div>
						1.按上下箭头键2.history|more分页显示3.vi /etc/profile找HISTSIZE=1000,说明你最多能存1000条历史记录.4.!!执行最近执行的命令5.history|he ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RnpRj0.html" rel="bookmark" class="title">又长又臭又慢的线段树 洛谷P1531 I Hate It</a>
					<div>
						这是一个单点修改的模板题 不过注意这个和hdu的还不太一样 最近似乎沉迷模板2333...... 需要注意一定要在最底层比较是否改动 贴代码 1 #include&lt;iostream&gt; 2  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGdW5o0.html" rel="bookmark" class="title">Centos6&period;5 python2&period;7连接mysql数据库</a>
					<div>
						1.环境是centos6.5 32位系统,python版本是2.7.12,mysql版本是5.5.22.准备好所需压缩包,MySQL-python-1.2.4b4.tar.gz  pip-6.0.7. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzB5oWM.html" rel="bookmark" class="title">bzoj1016：&lbrack;JSOI2008&rsqb;最小生成树计数</a>
					<div>
						思路:模拟kruskal的过程,可以发现对于所有权值相同的边,有很多种选择的方案,而且权值不同的边并不会相互影响,因为先考虑权值较小的边,权值比当前权值大的边显然不在考虑范围之内,而权值比当前权值小的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvzXkM.html" rel="bookmark" class="title">G2 2&period;0 更灵活、更强大、更完备的可视化引擎！</a>
					<div>
						概述 G2作为一款技术产品,自诞生以来,服务于广大的Web工程师群体和一部分数据分析师.一直来,G2 因其易用的语法和扎实的可视化理论基础,广受使用者好评.G2 1.x 的可视化能力已经非常强大,使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRNYA3.html" rel="bookmark" class="title">C&plus;&plus;标准程序读书笔记-第三章错误和异常处理</a>
					<div>
						1.命名空间(namespace)std C++标准程序库中的所有标示符都被定义于一个名为std的namespace 2.标准异常类别 (1)语言本身或标准程序库所抛出的所有异常,都派生自基类exce ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyoXRa3.html" rel="bookmark" class="title">算法：冒泡排序</a>
					<div>
						int[] arr={2,4,1,6,8};    for(int i=0;i&lt;arr.length-1;i++){    for(int j=0;j&lt;arr.length-(i+1);j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wNa510.html" rel="bookmark" class="title">php dump mysql 数据库，生成数据库脚本</a>
					<div>
						&lt;?PHP function db_dump($host,$user,$pwd,$db) { $mysqlconlink = mysql_connect($host,$user,$pwd , t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qb25z4.html" rel="bookmark" class="title">数组之判断取值</a>
					<div>
						&lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.01 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
